"use strict";
exports.__esModule = true;
var utils_1 = require("./utils");
var config_1 = require("./config");
function withCookie(ins, cc) {
    if (!ins) {
        throw Error("Error: object, function or class required as first param");
    }
    var instance = Object.assign({}, ins);
    var _a = config_1.getConfig(cc), noCookie = _a.noCookie, ssCookie = _a.ssCookie, defaultExp = _a.defaultExp, name = _a.name;
    var instanceName = name || (instance.constructor && instance.constructor.name) || "Object";
    Object.keys(instance).forEach(function (key) {
        var methodType = Object.getOwnPropertyDescriptor(instance, key);
        if (typeof instance[key] !== "function" &&
            methodType &&
            !methodType.get &&
            !methodType.set) {
            var blockS_1 = noCookie && noCookie.indexOf(key) !== -1;
            var cookieName_1 = instanceName + "_" + key;
            var keyV_1 = (!blockS_1 && utils_1.getCookie(cookieName_1, ssCookie)) || instance[key];
            var objD = blockS_1
                ? {
                    value: keyV_1,
                    enumerable: true
                }
                : {
                    set: function (value) {
                        keyV_1 = value;
                        if (!blockS_1) {
                            utils_1.setCookie(cookieName_1, value, defaultExp);
                        }
                    },
                    get: function () {
                        return keyV_1;
                    }
                };
            Object.defineProperty(instance, key, objD);
        }
    });
    return instance;
}
exports.withCookie = withCookie;
//# sourceMappingURL=main.js.map